theory Foo
imports "../Auxiliaries/Util"
begin

(*from ITS/Fresh_Variable_Addition.thy (by Akihisa)*)
lemma rtrancl_O_push:
  assumes "r O s \<subseteq> s O r\<^sup>*"
  shows "r\<^sup>* O s \<subseteq> s O r\<^sup>*"
proof -
  { fix n
    have "\<And>x y. (x, y) \<in> r ^^ n O s \<Longrightarrow> (x, y) \<in> s O r\<^sup>*"
    proof (induct n)
      case (Suc n)
      then obtain u where "(x, u) \<in> r" and "(u, y) \<in> s O r\<^sup>*" unfolding relpow_Suc by blast
      then obtain v where "(x, v) \<in> r O s" and "(v, y) \<in> r\<^sup>*" by auto
      moreover then have "(x, v) \<in> s O r\<^sup>*" using assms by blast
      ultimately show ?case by auto
    qed auto }
  then show ?thesis by blast
qed

(*from ITS/Fresh_Variable_Addition.thy (by Akihisa)*)
lemma rtrancl_Un_push:
  assumes "r O s \<subseteq> s O r\<^sup>*"
  shows "(r \<union> s)\<^sup>* = s\<^sup>* O r\<^sup>*"
proof (intro equalityI subrelI)
  fix x y
  assume "(x, y) \<in> (r \<union> s)\<^sup>*"
  also have "... \<subseteq> (r\<^sup>* O s)\<^sup>* O r\<^sup>*" by regexp
  finally obtain z where xz: "(x, z) \<in> (r\<^sup>* O s)\<^sup>*" and zy: "(z, y) \<in> r\<^sup>*" by auto
  from xz have "(x, z) \<in> s\<^sup>* O r\<^sup>*"
  proof (induct rule: rtrancl_induct)
    case (step z w)
      then have "(x, w) \<in> s\<^sup>* O r\<^sup>* O r\<^sup>* O s" by auto
      also have "... \<subseteq> s\<^sup>* O r\<^sup>* O s" by regexp
      also have "... \<subseteq> s\<^sup>* O s O r\<^sup>*" using rtrancl_O_push [OF assms] by auto
      also have "... \<subseteq> s\<^sup>* O r\<^sup>*" by regexp
      finally show ?case.
  qed auto
  with zy show "(x, y) \<in> s\<^sup>* O r\<^sup>*" by auto
qed regexp

lemma SN_trancl_Un:
  assumes "r O s \<subseteq> s O r\<^sup>*" and "SN r" and "SN s"
  shows "SN ((r \<union> s)\<^sup>+)"
proof (rule ccontr)
  assume "\<not> ?thesis"
  then obtain f where "\<And>i. (f i, f (Suc i)) \<in> (r \<union> s)\<^sup>+" by fast
  then show False
  proof (induct "f 0" arbitrary: f rule: SN_induct [OF \<open>SN s\<close>])
    let ?rs = "(r \<union> s)"
    case IH: 1
    moreover have "?rs\<^sup>+ = r\<^sup>+ \<union> (?rs\<^sup>* O s O ?rs\<^sup>*)" by regexp
    ultimately obtain j where "(f j, f (Suc j)) \<in> ?rs\<^sup>* O s O ?rs\<^sup>*"
      using SN_imp_SN_trancl [OF \<open>SN r\<close>] by blast
    moreover have "(f 0, f j) \<in> ?rs\<^sup>*"
      using IH(2) by (induct j) (auto intro: trancl_into_rtrancl rtrancl_trancl_trancl)
    ultimately obtain u where "(f 0, u) \<in> ?rs\<^sup>* O s" and "(u, f (Suc j)) \<in> ?rs\<^sup>*"
      by (auto dest: rtrancl_trans)
    moreover have "s\<^sup>* O r\<^sup>* O s \<subseteq> s\<^sup>* O s O r\<^sup>*"
      using rtrancl_O_push [OF assms(1)] by (intro relcomp_mono [OF subset_refl])
    moreover have "s\<^sup>* O s O r\<^sup>* = s O s\<^sup>* O r\<^sup>*" by regexp
    ultimately have "(f 0, f (Suc j)) \<in> s O ?rs\<^sup>* O s\<^sup>* O r\<^sup>*"
      unfolding rtrancl_Un_push [OF assms(1)] O_assoc by simp blast
    moreover have "s O ?rs\<^sup>* O s\<^sup>* O r\<^sup>* \<subseteq> s O ?rs\<^sup>*" by regexp
    ultimately obtain v and n where "(f 0, v) \<in> s" and "(v, f (Suc j)) \<in> ?rs ^^ n" by blast
    moreover def g \<equiv> "case_nat v (case_nat (\<lambda>i. f (i + j + 2)) (\<lambda>_ i. f (i + j + 1)) n)"
    ultimately have "(f 0, g 0) \<in> s" and "\<And>i. (g i, g (Suc i)) \<in> ?rs\<^sup>+"
      using IH(2) by (auto split: nat.splits simp: trancl_power)
    with IH(1) show False by blast
  qed
qed

end
